#include <msp/fs/stat.h>
#include "csourcefile.h"
#include "gnucxxcompiler.h"

using namespace std;
using namespace Msp;

GnuCxxCompiler::GnuCxxCompiler(Builder &b, const Architecture &a, const FS::Path &sysroot):
	GnuCompiler(b, a, "CXX", sysroot)
{
	set_command("g++", true);
	input_suffixes.push_back(".cpp");
	input_suffixes.push_back(".cc");
	aux_suffixes.push_back(".hpp");
}

Target *GnuCxxCompiler::create_source(const Component &comp, const FS::Path &path) const
{
	return new CSourceFile(builder, comp, path);
}

Target *GnuCxxCompiler::create_source(const FS::Path &path) const
{
	return new CSourceFile(builder, path);
}

void GnuCxxCompiler::do_prepare()
{
	GnuCompiler::do_prepare();
	if(!version.empty())
	{
		FS::Path cxx_path = FS::Path("/usr/include/c++")/version;
		if(FS::is_dir(cxx_path))
			system_path.push_back(cxx_path);
	}
}
