#include <stdexcept>
#include "pattern.h"

using namespace std;

Pattern::Pattern(const string &pat)
{
	string::size_type percent = pat.find('%');
	if(percent==string::npos)
		throw invalid_argument("No percent sign in pattern");
	prefix = pat.substr(0, percent);
	suffix = pat.substr(percent+1);
}

string Pattern::apply(const string &body) const
{
	return prefix+body+suffix;
}

list<string> Pattern::apply_list(const list<Pattern> &patterns, const string &body)
{
	list<string> result;
	for(list<Pattern>::const_iterator i=patterns.begin(); i!=patterns.end(); ++i)
		result.push_back(i->apply(body));
	return result;
}
