#ifndef STATICLIBRARY_H_
#define STATICLIBRARY_H_

#include "filetarget.h"

class Component;
class ObjectFile;

/**
A static library target.
*/
class StaticLibrary: public FileTarget
{
public:
	StaticLibrary(Builder &, const Msp::FS::Path &);
	StaticLibrary(Builder &, const Component &, const std::list<ObjectFile *> &);
private:
	static std::string generate_filename(const Component &);

public:
	virtual const char *get_type() const { return "StaticLibrary"; }
};

#endif
